﻿using Infragistics.Documents.Excel;
using Infragistics.Windows.DataPresenter.ExcelExporter;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace ExportExcelHang
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public ObservableCollection<RowData> Data { get; set; }
        private Random _random = new Random();
        
        public MainWindow()
        {
            InitializeComponent();
            Loaded += MainWindow_Loaded;
        }

        void MainWindow_Loaded(object sender, RoutedEventArgs e)
        {
            Data = new ObservableCollection<RowData>();
            for (int i = 0; i < 10000; i++)
            {
                RowData data = new RowData();
                for (int j = 0; j < 30; j++)
                {
                    data.GetType().GetProperty("column" + (j + 1).ToString()).SetValue(data, _random.Next().ToString());
                }

                Data.Add(data);
            }

            xamDataGrid1.DataSource = Data;
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            DataPresenterExcelExporter exporter = new DataPresenterExcelExporter();
            Stopwatch sw = new Stopwatch();
            sw.Start();
            exporter.Export(xamDataGrid1, "myExport.xls", WorkbookFormat.Excel97To2003);
            sw.Stop();
            MessageBox.Show("Export took " + sw.Elapsed.TotalSeconds + " seconds");
        }
    }

    public class RowData
    {
        public string column1 { get; set; }
        public string column2 { get; set; }
        public string column3 { get; set; }
        public string column4 { get; set; }
        public string column5 { get; set; }
        public string column6 { get; set; }
        public string column7 { get; set; }
        public string column8 { get; set; }
        public string column9 { get; set; }
        public string column10 { get; set; }
        public string column11 { get; set; }
        public string column12 { get; set; }
        public string column13 { get; set; }
        public string column14 { get; set; }
        public string column15 { get; set; }
        public string column16 { get; set; }
        public string column17 { get; set; }
        public string column18 { get; set; }
        public string column19 { get; set; }
        public string column20 { get; set; }
        public string column21 { get; set; }
        public string column22 { get; set; }
        public string column23 { get; set; }
        public string column24 { get; set; }
        public string column25 { get; set; }
        public string column26 { get; set; }
        public string column27 { get; set; }
        public string column28 { get; set; }
        public string column29 { get; set; }
        public string column30 { get; set; }
    }
}
